# LiquidityManagement

Internal functions for safely managing liquidity in DragonswapV2

### Parameter Structs[​](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#parameter-structs) <a href="#parameter-structs" id="parameter-structs"></a>

#### AddLiquidityParams[​](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#addliquidityparams) <a href="#addliquidityparams" id="addliquidityparams"></a>

```solidity
    struct AddLiquidityParams {
        address token0;
        address token1;
        uint24 fee;
        address recipient;
        int24 tickLower;
        int24 tickUpper;
        uint256 amount0Desired;
        uint256 amount1Desired;
        uint256 amount0Min;
        uint256 amount1Min;
    }
```

### Functions[​](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#functions) <a href="#functions" id="functions"></a>

#### dragonswapV2MintCallback[​](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#uniswapv3mintcallback) <a href="#uniswapv3mintcallback" id="uniswapv3mintcallback"></a>

```solidity
  function dragonswapV2MintCallback(
    uint256 amount0Owed,
    uint256 amount1Owed,
    bytes data
  ) external
```

Called to `msg.sender` after minting liquidity to a position from IDragonswapV2Pool#mint.

In the implementation you must pay the pool tokens owed for the minted liquidity. The caller of this method must be checked to be a DragonswapV2Pool deployed by the canonical DragonswapV2Factory.

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#parameters)

| Name          | Type    | Description                                                                      |
| ------------- | ------- | -------------------------------------------------------------------------------- |
| `amount0Owed` | uint256 | The amount of token0 due to the pool for the minted liquidity                    |
| `amount1Owed` | uint256 | The amount of token1 due to the pool for the minted liquidity                    |
| `data`        | bytes   | Any data passed through by the caller via the IDragonswapV2PoolActions#mint call |

#### addLiquidity[​](https://docs.uniswap.org/contracts/v3/reference/periphery/base/LiquidityManagement#addliquidity) <a href="#addliquidity" id="addliquidity"></a>

```solidity
  function addLiquidity(
    AddLiquidityParams memory params
  ) internal returns (uint128 liquidity, uint256 amount0, uint256 amount1, contract IDragonswapV2Pool pool)
```

Add liquidity to an initialized pool

<br>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/periphery/base/liquiditymanagement.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
